"use strict";

const path = require("path");
function userIgnoreFilter(opts, appDir) {
    let ignore = opts.ignore || [];
    let ignoreFunc;
    if (typeof ignore === "function") {
        ignoreFunc = function (file) {
            return !ignore(file);
        };
    } else {
        if (!Array.isArray(ignore)) {
            ignore = [ignore];
        }
        ignoreFunc = function (file) {
            for (let i = 0; i < ignore.length; i++) {
                if (file.match(ignore[i])) {
                    return false;
                }
            }
            return true;
        };
    }
    return function filter(file) {
        let name = file.split(path.resolve(appDir))[1];
        if (path.sep === "\\") {
            // convert slashes so unix-format ignores work
            name = name.replace(/\\/g, "/");
        }
        return ignoreFunc(name);
    };
}
exports.userIgnoreFilter = userIgnoreFilter;
function initializeApp(opts, buildDir, appRelativePath) {
    return opts.initializeApp(opts, buildDir, appRelativePath);
}
exports.initializeApp = initializeApp;
//# sourceMappingURL=common.js.map